import twitter4j.conf.*;
import twitter4j.internal.async.*;
import twitter4j.internal.org.json.*;
import twitter4j.internal.logging.*;
import twitter4j.http.*;
import twitter4j.api.*;
import twitter4j.util.*;
import twitter4j.internal.http.*;
import twitter4j.*;
import processing.serial.*;
import cc.arduino.*;

static String OAuthConsumerKey = "PRjIIBEvOUJMtXxHoOjw";
static String OAuthConsumerSecret = "6wgQWlFWx7yH6lXDOrDoLCJDILqdAkV7aSA1vZCGM";
static String AccessToken = "974495264-CbEiy810dkqvKcBWKPgBkUsmm0dn7AowLtVi9L0s";
static String AccessTokenSecret = "9rf5UYGwSTQrfsT06NNQxPBGwn1Zqg3ex0V5Ee97E";

//Serial myArduinoSerial;
Twitter twitter = new TwitterFactory().getInstance();

//this object class Arduino
//represents guess what? Your board
Arduino arduino;

//like in an arduino sketch it's good to
//use variables for pin numbers 
int ledPin = 13;
int sensorPin = 0;

//twitter variables
String mostRecentTweetString;
Date   mostRecentTweetDate;
int    mostRecentTweetId;
int    previousTweetId = 0; 


//===========================================================================
void setup() {
  size(125, 125);
  frameRate(10);
  background(0);

  loginTwitter();

  println(Arduino.list());
  println("Make sure that in the initialization Arduino.list()[n], n is the port corresponding to /dev/tty.usbmodem...");

  //the arduino object needs to be created at the beginning
  arduino = new Arduino(this, Arduino.list()[0], 57600);

  //once it's created I set the pin modes  
  arduino.pinMode(ledPin, Arduino.OUTPUT);
  arduino.pinMode(sensorPin, Arduino.INPUT);
}


//===========================================================================
void draw() {
  //turn off the LED
  arduino.digitalWrite(ledPin, Arduino.LOW); 

  //read the most recent tweet
  println("Contacting Twitter - " + hour() + ":" + minute()+ ":" +second());
  getMostRecentTweet();

  //You can read from a specific user
  //by specifying an id
  //getMostRecentTweet(357001672);
  //http://www.idfromuser.com

  if (previousTweetId == 0) {
    previousTweetId = mostRecentTweetId;
  }
  //check if something changed
  if (mostRecentTweetId != previousTweetId) {
    previousTweetId = mostRecentTweetId;
    println ("String = " + mostRecentTweetString) ;
    println ("Id#    = " + mostRecentTweetId) ;
    println ("Date   = " + mostRecentTweetDate.toString()) ; 
    println ("----------------");

    //if I tweet a status with the word "sensor" in it the sketch tweets the local 
    //sensor value and turns on the LED until the next scan
    String keyword = "sensor";

    //indexOf returns the char position OR -1 if no mathces are found
    int locationOfTestStringInTweet = mostRecentTweetString.indexOf(keyword);

    if (locationOfTestStringInTweet != -1) {

      int analogValue =  arduino.analogRead(sensorPin);
      sendTweet("The value at " + hour() + ":" + minute()+ ":" +second() + " was: "+analogValue);

      arduino.digitalWrite(ledPin, Arduino.HIGH);
    }
  }

  // REALLY IMPORTANT, PEOPLE. You're limited to 350 requests per hour, or about once per 11 seconds.  
  delay (12000);
}


// Sending a tweet
void sendTweet(String t) {

  try {
    Status status = twitter.updateStatus(t);
    println("Successfully updated the status to [" + status.getText() + "].");
  } 
  catch(TwitterException e) { 
    println("Send tweet: " + e + " Status code: " + e.getStatusCode());
  }
}



void loginTwitter() {
  twitter.setOAuthConsumer(OAuthConsumerKey, OAuthConsumerSecret);
  AccessToken accessToken = new AccessToken(AccessToken, AccessTokenSecret);
  twitter.setOAuthAccessToken(accessToken);
}

void getMostRecentTweet() {
  getMostRecentTweet(-1);
}


//===========================================================================
void getMostRecentTweet(int id) {

  java.util.List statuses = null;
  try {
    //read the user's timeline
    if (id == -1)
      statuses = twitter.getUserTimeline(); 
    else
      statuses = twitter.getUserTimeline (id);

    // get the user id from http://www.idfromuser.com
  }
  catch(TwitterException e) {
    println("Timeline Error: " + e + "; statusCode: " + e.getStatusCode());
  }

  // see: http://twitter4j.org/en/javadoc/index.html
  // see: http://twitter4j.org/en/javadoc/twitter4j/Status.html
  if (statuses != null) {
    Status mostRecentStatus  = (Status)statuses.get(0);
    mostRecentTweetString  = mostRecentStatus.getText();
    mostRecentTweetId      = (int) mostRecentStatus.getId();
    mostRecentTweetDate    = mostRecentStatus.getCreatedAt();

    boolean printDiagnosticStuff = false;
    if (printDiagnosticStuff) {
      println ("String = " + mostRecentTweetString) ;
      println ("Id#    = " + mostRecentTweetId) ;
      println ("Date   = " + mostRecentTweetDate.toString()) ; 
      println ("----------------");
    }
  }
}

